//+------------------------------------------------------------------+
class CNXdouble
{
	double						value[];
	int							size[];
	int							index;
	int							ivalue;
public:
									CNXdouble(const int &n[]);
						  	  	  ~CNXdouble()	{ ArrayFree(value); ArrayFree(size);}
	double 	  operator[]   (long x_);
	CNXdouble *operator[] 	(int x_) 	{ ivalue+=x_*size[index++]; return(GetPointer(this));}
	void       operator=	   (double d)	{ value[ivalue]=d; index=0; ivalue=0;}
};
//+------------------------------------------------------------------+
CNXdouble::CNXdouble(const int &n[])
{
	int m=1, k=ArraySize(n);
	ArrayResize(size,k);
	size[k-1]=1;
	for(int i=k-2; i>=0; i--) size[i]=n[i+1]*size[i+1];
	for(int i=0; i<k; i++) m*=n[i];
	ArrayResize(value,m);
	index=0;
	ivalue=0;
}
//+------------------------------------------------------------------+
double CNXdouble::operator[]    (long x_) 
{
	index=0;
	int i=ivalue;
	ivalue=0;
	return(value[i+(int)x_]);
}
//+------------------------------------------------------------------+
void OnStart()
{
	int n[]={2,3,4,2};	// 4-  
	int a1=n[0], a2=n[1], a3=n[2], a4=n[3];
	CNXdouble d2(n);
	//  
	int c=0;
	for(int i=0; i<a1; i++)
		for(int j=0; j<a2; j++) 
			for(int x=0; x<a3; x++) 
				for(int y=0; y<a4; y++)
					d2[i][j][x][y]=(double)c++;
	//  
	string s="";
   for(int i=0; i<a1; i++)
		for(int j=0; j<a2; j++) 
			for(int x=0; x<a3; x++)
				for(long y=0; y<a4; y++)
					s+=(string)d2[i][j][x][y]+" ";
   Print(s);
}
//+------------------------------------------------------------------+